/* license: AGPLv3 or later */
/* copyright 2023 zamfofex */

#include <mimimi.h>

static struct mimimi_layer mimimi_head_origin =
{
	0, -1, 0, 0, 32, 0, {{0}},
};

static struct mimimi_layer mimimi_head_value =
{
	0, 12, 0, 12, 32, 12,
	{
		{6, 6, 1, {0xF9}},
		{8, 8, 1, {0xF9}},
		{10, 10, 1, {0xF9}},
		{12, 12, 1, {0xF9}},
		{12, 12, 1, {0xF9}},
		{12, 12, 1, {0xF9}},
		{12, 12, 1, {0xF9}},
		{12, 12, 1, {0xF9}},
		{12, 12, 1, {0xF9}},
		{10, 10, 1, {0xF9}},
		{8, 8, 1, {0xF9}},
		{6, 6, 1, {0xF9}},
	},
};

static struct mimimi_layer mimimi_torso_value =
{
	0, 12, 0, 6, 32, 12,
	{
		{6, 4, 1, {0xF9}},
		{8, 4, 1, {0xF9}},
		{10, 6, 1, {0xF9}},
		{10, 6, 1, {0xF9}},
		{10, 6, 1, {0xF9}},
		{10, 6, 1, {0xF9}},
		{10, 6, 1, {0xF9}},
		{10, 6, 1, {0xF9}},
		{10, 6, 1, {0xF9}},
		{10, 6, 1, {0xF9}},
		{10, 6, 1, {0xF9}},
		{10, 6, 1, {0xF9}},
		{10, 6, 1, {0xF9}},
		{8, 4, 1, {0xF9}},
		{6, 4, 1, {0xF9}},
	},
};

static struct mimimi_layer mimimi_upper_left_arm_value =
{
	0, -1, -4, 4, 96, 7,
	{
		{2, 2, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{2, 2, 1, {0xF9}},
	},
};

static struct mimimi_layer mimimi_upper_right_arm_value =
{
	0, -1, 4, 4, 96, 7,
	{
		{2, 2, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{2, 2, 1, {0xF9}},
	},
};

static struct mimimi_layer mimimi_lower_left_arm_value =
{
	0, -5, 0, 4, 32, 7,
	{
		{2, 2, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{2, 2, 1, {0xF9}},
	},
};

static struct mimimi_layer mimimi_lower_right_arm_value =
{
	0, -5, 0, 4, 32, 7,
	{
		{2, 2, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{2, 2, 1, {0xF9}},
	},
};

static struct mimimi_layer mimimi_upper_left_leg_value =
{
	0, -11, -3, 4, 32, 7,
	{
		{2, 2, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{2, 2, 1, {0xF9}},
	},
};

static struct mimimi_layer mimimi_upper_right_leg_value =
{
	0, -11, 3, 4, 32, 7,
	{
		{2, 2, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{2, 2, 1, {0xF9}},
	},
};

static struct mimimi_layer mimimi_lower_left_leg_value =
{
	0, -5, 0, 4, 32, 7,
	{
		{2, 2, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{2, 2, 1, {0xF9}},
	},
};

static struct mimimi_layer mimimi_lower_right_leg_value =
{
	0, -5, 0, 4, 32, 7,
	{
		{2, 2, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{4, 4, 1, {0xF9}},
		{2, 2, 1, {0xF9}},
	},
};

static struct mimimi_layer mimimi_empty_layer = {0};

#include "mango.c"
#include "pepper.c"
